clear 
clc

% suspension resonant frequency
w0 = 2*pi*1.;
% suspension Q
Q = 1000;

% Sensor gain 
Gsens = 1e7; % in m/V

% Sensor gain 
% Same gain as the second example of the DC control
GservoZ = [-3 -10];
GservoP = [0.1 -100 -100];
GservoK = 2e5;

% Mitigation by a notch filter
GservoZ = [-3 -10 -0.1+100*i -0.1+-100*i]; 
GservoP = [0.1 -70 -70 -10+100*i -10+-100*i];
GservoK = 1e5;

% actuator DC response
act = 1e-6; % in Newton/kg / Volt (= m/s^2 / Volt)

% suspension resonant frequency
w1 = 2*pi*100.;
act1 = 1e-10

% Makes the State-Space object from the .mdl
[A,B,C,D] = linmod2('Model_Servo1_parasitic');
% warning off
model_sys = ss(A,B,C,D);

%%% Run application
% Suspension resposnes
% figure(1)
% Sus_resp;

% Openloop transfer function
figure(2)
openloop_resp;
subplot(3,1,[1 2]);
ylim([1e-4 1e5])
set(gca,'YTick',10.^[-4:5]);

% Suspension resposnes
figure(3)
Loop_suppression;

% % Green PDH open loop tf
% PDH_OL_resp;
% 
% % ALS open loop tf
% ALS_OL_resp;        
% 
% % ALS performance
% % Supression of the arm length fluctuation
% % CAUTION: Arm freq noise is defined for 532nm. 
% % For 1064nm, the fnoise is half. Therefore this plot
% % has -6dB at high freq. For the displacement wise, 
% % we need to multiply by a factor of 2
% Arm_Stabil_resp;
% 
% % TF from freq noise of the green laser to the resultant freq noise
% Green_fnoise_resp;
% 
% % TF from freq-noise-equivalent shot noise of the green PDH 
% % to the resultant freq noise
% Green_snoise_resp;
% 
% % TF from freq noise of the PSL to the resultant freq noise
% PSL_fnoise_resp;
% 
% % TF from freq noise equivalent of the MC fluctuation (for 1064nm)
% % to the resultant freq noise
% % This freq noise correspods to the stability with the MC length stabilization.
% MC_fnoise_resp;
% 
% % TF from freq noise of the PLL VCO to the resultant freq noise
% ALS_VCOfnoise_resp;
% 
% % TF from phase-noise-equivalent shot noise of the PLL
% ALS_snoise_resp;
