% set up frequencies
fmin = -1;
fmax = 3;
f = logspace(fmin,fmax,1000);

% seis free run
tf_free  = model_sys(5, 1);
g_free = mybodesys(tf_free,f);

% seis noise contribution
tf_Nseis_stability  = model_sys(4, 1);
tf_Nseis_err        = model_sys(1, 1);
tf_Nseis_fb         = model_sys(2, 1);

g_Nseis_stability = mybodesys(tf_Nseis_stability,f);
g_Nseis_err       = mybodesys(tf_Nseis_err      ,f);
g_Nseis_fb        = mybodesys(tf_Nseis_fb       ,f);

% sensing noise contribution
tf_Nsens_stability  = model_sys(4, 3);
tf_Nsens_err        = model_sys(1, 3);
tf_Nsens_fb         = model_sys(2, 3);

g_Nsens_stability = mybodesys(tf_Nsens_stability,f);
g_Nsens_err       = mybodesys(tf_Nsens_err      ,f);
g_Nsens_fb        = mybodesys(tf_Nsens_fb       ,f);

% sensing noise contribution
tf_Nsens_stability  = model_sys(4, 3);
tf_Nsens_err        = model_sys(1, 3);
tf_Nsens_fb         = model_sys(2, 3);

g_Nsens_stability = mybodesys(tf_Nsens_stability,f);
g_Nsens_err       = mybodesys(tf_Nsens_err      ,f);
g_Nsens_fb        = mybodesys(tf_Nsens_fb       ,f);

% filter noise contribution
tf_Nfilt_stability  = model_sys(4, 4);
tf_Nfilt_err        = model_sys(1, 4);
tf_Nfilt_fb         = model_sys(2, 4);

g_Nfilt_stability = mybodesys(tf_Nfilt_stability,f);
g_Nfilt_err       = mybodesys(tf_Nfilt_err      ,f);
g_Nfilt_fb        = mybodesys(tf_Nfilt_fb       ,f);

% filter noise contribution
tf_Nact_stability  = model_sys(4, 5); 
tf_Nact_err        = model_sys(1, 5); 
tf_Nact_fb         = model_sys(2, 5); 

g_Nact_stability = mybodesys(tf_Nact_stability,f);
g_Nact_err       = mybodesys(tf_Nact_err      ,f);
g_Nact_fb        = mybodesys(tf_Nact_fb       ,f);

x_free = abs(g_free).*x_seis;
x_Nseis_stability = abs(g_Nseis_stability).*x_seis;

x_Nsens_stability = abs(g_Nsens_stability).*n_sens;

x_Nfilt_stability = abs(g_Nfilt_stability).*n_filt;

x_Nact_stability = abs(g_Nact_stability).*n_act;

clf;
loglog(f,x_free,'k', 'LineWidth',1);
hold on;
loglog(f,x_Nseis_stability,'r', 'LineWidth',2);
loglog(f,x_Nsens_stability,'b', 'LineWidth',2);
loglog(f,x_Nfilt_stability,'g', 'LineWidth',2);
loglog(f,x_Nact_stability, 'm', 'LineWidth',2);
set(gca,'FontSize',14);
set(gca,'GridLineStyle','--');
set(gca,'Color',[1 1 1])
grid on;
%ylim([1e-4 1e2]);
legend(...
    'Free run',...
    'Stabilized',...
    'Sensor noise',...
    'Filter noise',...
    'Actuator noise',...
    'Location', 'NorthEast'...
);
title('Suspension stablized displacement');
xlabel('Frequency (Hz)');
ylabel('Displacement noise (m/rtHz)');

orient landscape;
% print -dpdf 'Model_SUS_resp.pdf'